%undefine _missing_build_ids_terminate_build
%global _unpackaged_files_terminate_build 1

%if %{defined _project}
# define if building on openSUSE build service
%global build_on_obs       1
%global reconfigure_mode   0
%else
%define _project           local
%global build_on_obs       0
%global reconfigure_mode   0
%global _hardened_build    1
%endif

%if %{defined nodebug}
%global debug_package      %{nil}
%endif

Name: libqmail
Version: 1.5
Release: 1.1%{?dist}
Summary: General Purpose library for indimail-mta, daemontools, ucspi-tcp
%if %{undefined suse_version} && %{undefined sles_version}
Group: System Environment/Libraries
%else
Group: System/Libraries
%endif
%if %build_on_obs == 1
License: GPL-2.0
%else
License: GPLv2
%endif
URL: https://github.com/indimail/libqmail
Source0: http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.gz
%global see_base For a description of IndiMail visit http://www.indimail.org
%global mandir %{_prefix}/share/man
%global docdir %{_prefix}/share/doc/%{name}
%global _pkg_config_path   /usr/%{_lib}/pkgconfig
BuildRequires: rpm gcc gcc-c++ make binutils coreutils grep
BuildRequires: glibc glibc-devel openssl-devel sed
BuildRequires: gzip autoconf automake libtool pkgconfig
BuildRequires: xz
%if 0%{?centos_version} > 700 || 0%{?rhel_version} > 700 || 0%{?scientific_version} > 700 || 0%{?centos_ver} > 7 || %{defined mgaversion} || %{defined fedora_version} || 0%{?is_opensuse} || 0%{?rocky_version} || 0%{?almalinux_version} || %{defined amzn} || 0%{?mageia}
BuildRequires: libsodium-devel
%endif
%if %build_on_obs == 1
%if 0%{?suse_version}
BuildRequires: -post-build-checks  
#!BuildIgnore: post-build-checks  
%endif
%endif

AutoReqProv: Yes
Provides: qmail-libs = %{version}
Provides: qmail-libs%{?_isa} = %{version}

%description
libqmail provides qmail libraries extracted from qmail-1.03 and
other software written by djb.
Included APIs:
* wrappers around memory allocation, stralloc (dynamic strings)
* substdio buffered I/O
* byte - contains formatting, scanning and other string routines
* tai - contains an abstraction for 64-bit system time
* timeout - contains versions of several socket routines with user specified
  timeout
* unix - contains wrappers for socket functions, mkfifo, opendir, wait and an
  abstraction around errno.
* sig - contains wrappers for Unix signal functions
* tls/ssl - contains tls/ssl functions

%{see_base}

%package -n libqmail-devel
Summary: Development header files and libraries for qmail
%if %{undefined suse_version} && %{undefined sles_version}
Group: System Environment/Libraries
%else
Group: Development/Tools/Other
%endif
Requires: libqmail >= %{version}

%description -n libqmail-devel
This package contains the development header files and libraries
necessary to develop qmail applications

%{see_base}

%prep
%setup -q

%build
%configure --prefix=/usr --sysconfdir=/etc/indimail \
  --enable-passwd-hash=sha256

%install
%{__make} -s %{?_smp_mflags}
%if %{defined nodebug}
  %{__make} -s %{?_smp_mflags} DESTDIR=%{buildroot} install-strip
%else
  %{__make} -s %{?_smp_mflags} DESTDIR=%{buildroot} install
%endif
for i in %{name} %{name}-devel
do
  %{__mkdir_p} %{buildroot}%{_prefix}/share/doc/$i
  install -p -m 0644 COPYING %{buildroot}%{_prefix}/share/doc/$i
  install -p -m 0644 AUTHORS %{buildroot}%{_prefix}/share/doc/$i
  install -p -m 0644 doc/ChangeLog %{buildroot}%{_prefix}/share/doc/$i
  install -p -m 0644 README.md %{buildroot}%{_prefix}/share/doc/$i
done
%{__rm} -f %{buildroot}%{_libdir}/libqmail.la

%files
%defattr(-, root, root, 0755)
%{_libdir}/libqmail.so.1
%{_libdir}/libqmail.so.1.0.0

%if %build_on_obs == 0
%license %attr(0644,root,root)          %{_prefix}/share/doc/%{name}/COPYING
%else
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/COPYING
%endif
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/AUTHORS
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/ChangeLog
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}/README.md

%files devel
%defattr(-, root, root, 0755)
%dir %attr(755,root,root)               %{_prefix}/include/qmail
%doc %attr(644,root,root)               %{mandir}/man3/*

%attr(644,root,root)                    %{_prefix}/include/qmail/alloc.h
%attr(644,root,root)                    %{_prefix}/include/qmail/allwrite.h
%attr(644,root,root)                    %{_prefix}/include/qmail/arc4random.h
%attr(644,root,root)                    %{_prefix}/include/qmail/authmethods.h
%attr(644,root,root)                    %{_prefix}/include/qmail/base64.h
%attr(644,root,root)                    %{_prefix}/include/qmail/buffer.h
%attr(644,root,root)                    %{_prefix}/include/qmail/builtinoflmacros.h
%attr(644,root,root)                    %{_prefix}/include/qmail/byte.h
%attr(644,root,root)                    %{_prefix}/include/qmail/caldate.h
%attr(644,root,root)                    %{_prefix}/include/qmail/caltime.h
%attr(644,root,root)                    %{_prefix}/include/qmail/case.h
%attr(644,root,root)                    %{_prefix}/include/qmail/cdb.h
%attr(644,root,root)                    %{_prefix}/include/qmail/cdb_make.h
%attr(644,root,root)                    %{_prefix}/include/qmail/cdbmake.h
%attr(644,root,root)                    %{_prefix}/include/qmail/cdbmss.h
%attr(644,root,root)                    %{_prefix}/include/qmail/check_domain.h
%attr(644,root,root)                    %{_prefix}/include/qmail/coe.h
%attr(644,root,root)                    %{_prefix}/include/qmail/commands.h
%attr(644,root,root)                    %{_prefix}/include/qmail/constmap.h
%attr(644,root,root)                    %{_prefix}/include/qmail/date822fmt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/datetime.h
%attr(644,root,root)                    %{_prefix}/include/qmail/digest_md5.h
%attr(644,root,root)                    %{_prefix}/include/qmail/direntry.h
%attr(644,root,root)                    %{_prefix}/include/qmail/env.h
%attr(644,root,root)                    %{_prefix}/include/qmail/envdir.h
%attr(644,root,root)                    %{_prefix}/include/qmail/error.h
%attr(644,root,root)                    %{_prefix}/include/qmail/evaluate.h
%attr(644,root,root)                    %{_prefix}/include/qmail/fd.h
%attr(644,root,root)                    %{_prefix}/include/qmail/fifo.h
%attr(644,root,root)                    %{_prefix}/include/qmail/fmt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/hasbltnofl.h
%attr(644,root,root)                    %{_prefix}/include/qmail/hmac.h
%attr(644,root,root)                    %{_prefix}/include/qmail/in_crypt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/iopause.h
%attr(644,root,root)                    %{_prefix}/include/qmail/gen_allocdefs.h
%attr(644,root,root)                    %{_prefix}/include/qmail/gen_alloc.h
%attr(644,root,root)                    %{_prefix}/include/qmail/getEnvConfig.h
%attr(644,root,root)                    %{_prefix}/include/qmail/get_scram_secrets.h
%attr(644,root,root)                    %{_prefix}/include/qmail/getln.h
%attr(644,root,root)                    %{_prefix}/include/qmail/global.h
%attr(644,root,root)                    %{_prefix}/include/qmail/hashmethods.h
%attr(644,root,root)                    %{_prefix}/include/qmail/rewritehost.h
%attr(644,root,root)                    %{_prefix}/include/qmail/leapsecs.h
%attr(644,root,root)                    %{_prefix}/include/qmail/lock.h
%attr(644,root,root)                    %{_prefix}/include/qmail/makeargs.h
%attr(644,root,root)                    %{_prefix}/include/qmail/makesalt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/matchregex.h
%attr(644,root,root)                    %{_prefix}/include/qmail/md5.h
%attr(644,root,root)                    %{_prefix}/include/qmail/mess822.h
%attr(644,root,root)                    %{_prefix}/include/qmail/mkpasswd.h
%attr(644,root,root)                    %{_prefix}/include/qmail/mktempfile.h
%attr(644,root,root)                    %{_prefix}/include/qmail/ndelay.h
%attr(644,root,root)                    %{_prefix}/include/qmail/noreturn.h
%attr(644,root,root)                    %{_prefix}/include/qmail/now.h
%attr(644,root,root)                    %{_prefix}/include/qmail/no_of_days.h
%attr(644,root,root)                    %{_prefix}/include/qmail/open.h
%attr(644,root,root)                    %{_prefix}/include/qmail/openreadclose.h
%attr(644,root,root)                    %{_prefix}/include/qmail/pathexec.h
%attr(644,root,root)                    %{_prefix}/include/qmail/prot.h
%attr(644,root,root)                    %{_prefix}/include/qmail/pw_comp.h
%attr(644,root,root)                    %{_prefix}/include/qmail/qgetpwgr.h
%attr(644,root,root)                    %{_prefix}/include/qmail/qmailconfig.h
%attr(644,root,root)                    %{_prefix}/include/qmail/qprintf.h
%attr(644,root,root)                    %{_prefix}/include/qmail/qtime.h
%attr(644,root,root)                    %{_prefix}/include/qmail/readclose.h
%attr(644,root,root)                    %{_prefix}/include/qmail/replacestr.h
%attr(644,root,root)                    %{_prefix}/include/qmail/ripemd.h
%attr(644,root,root)                    %{_prefix}/include/qmail/r_mkdir.h
%attr(644,root,root)                    %{_prefix}/include/qmail/scan.h
%attr(644,root,root)                    %{_prefix}/include/qmail/sconfig.h
%attr(644,root,root)                    %{_prefix}/include/qmail/seek.h
%attr(644,root,root)                    %{_prefix}/include/qmail/select.h
%attr(644,root,root)                    %{_prefix}/include/qmail/setuserid.h
%attr(644,root,root)                    %{_prefix}/include/qmail/sgetopt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/sha1.h
%attr(644,root,root)                    %{_prefix}/include/qmail/sig.h
%attr(644,root,root)                    %{_prefix}/include/qmail/sodium_random.h
%attr(644,root,root)                    %{_prefix}/include/qmail/stralloc.h
%attr(644,root,root)                    %{_prefix}/include/qmail/strerr.h
%attr(644,root,root)                    %{_prefix}/include/qmail/strmsg.h
%attr(644,root,root)                    %{_prefix}/include/qmail/str.h
%attr(644,root,root)                    %{_prefix}/include/qmail/subfd.h
%attr(644,root,root)                    %{_prefix}/include/qmail/subgetopt.h
%attr(644,root,root)                    %{_prefix}/include/qmail/substdio.h
%attr(644,root,root)                    %{_prefix}/include/qmail/taia.h
%attr(644,root,root)                    %{_prefix}/include/qmail/tai.h
%attr(644,root,root)                    %{_prefix}/include/qmail/tai2.h
%attr(644,root,root)                    %{_prefix}/include/qmail/timeoutread.h
%attr(644,root,root)                    %{_prefix}/include/qmail/timeoutwrite.h
%attr(644,root,root)                    %{_prefix}/include/qmail/timestamp.h
%attr(644,root,root)                    %{_prefix}/include/qmail/tls.h
%attr(644,root,root)                    %{_prefix}/include/qmail/token822.h
%attr(644,root,root)                    %{_prefix}/include/qmail/typesx.h
%attr(644,root,root)                    %{_prefix}/include/qmail/uint16.h
%attr(644,root,root)                    %{_prefix}/include/qmail/uint32.h
%attr(644,root,root)                    %{_prefix}/include/qmail/uint64.h
%attr(644,root,root)                    %{_prefix}/include/qmail/valid_password_chars.h
%attr(644,root,root)                    %{_prefix}/include/qmail/wait.h
%attr(644,root,root)                    %{_prefix}/include/qmail/wildmat.h
%attr(644,root,root)                    %{_prefix}/include/qmail/array.h
%attr(644,root,root)                    %{_prefix}/include/qmail/entities.h
%attr(644,root,root)                    %{_prefix}/include/qmail/textcode.h
%attr(644,root,root)                    %{_prefix}/include/qmail/iarray.h
%attr(644,root,root)                    %{_prefix}/include/qmail/likely.h
%attr(644,root,root)                    %{_prefix}/include/qmail/safemult.h
%attr(644,root,root)                    %{_prefix}/include/qmail/rangecheck.h
%attr(644,root,root)                    %{_prefix}/include/qmail/isnum.h
%attr(644,root,root)                    %{_prefix}/include/qmail/qdirname.h
%attr(644,root,root)                    %{_prefix}/include/qmail/tcpbind.h
%attr(644,root,root)                    %{_prefix}/include/qmail/tcpopen.h
%attr(644,root,root)                    %{_prefix}/include/qmail/udpopen.h
%attr(644,root,root)                    %{_prefix}/include/qmail/tcpremoteip.h

%{_libdir}/libqmail.so
%{_libdir}/libqmail.a
%{_pkg_config_path}/libqmail.pc

%if %build_on_obs == 0
%license %attr(0644,root,root)          %{_prefix}/share/doc/%{name}-devel/COPYING
%else
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}-devel/COPYING
%endif
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}-devel/AUTHORS
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}-devel/ChangeLog
%attr(0644,root,root)                   %{_prefix}/share/doc/%{name}-devel/README.md

%post
argv1=$1
if [ -z "$argv1" ] ; then
  argv1=0
fi
if [ "$argv1" -eq 2 ] ; then # upgrade
  # we are doing upgrade
  if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
    /sbin/ldconfig
  fi
fi

%postun
if [ "%{_libdir}" != "/usr/lib64" -a "%{_libdir}" != "/usr/lib" ] ; then
  /sbin/ldconfig
fi

%changelog
* Tue May 06 2025 16:53:22 +0000 Manvendra Bhangui <libqmail@indimail.org> 1.5-1.1%{?dist}
Release 1.5-1.1 Start 05/09/2024 End 24/12/2024
- tls.c: added imap to starttls enumeration
- case_uppers.c: added case_uppers() function
- case_upperb.c: added case_upperb() function
- pathexec_env.c: added pathexec_env_plus() to add env variables from plus
  variable
- commands.c, commands.h: added cmd_name() function
- Fix errors when using GCC14
- error.c, error.h: added error_invalid for EINVAL
